SystemOrganization addCategory: #RTVoronyjBuilder!
SystemOrganization addCategory: 'RTVoronyjBuilder-Test'!

!SequenceableCollection methodsFor: '*RTVoronyjBuilder' stamp: 'NataliaTymchuk 7/6/2014 23:29'!
uniquePairsDo: aBlock

	self size < 2 ifTrue: [ ^ self ].
	
	(self allButLast: 1) withIndexDo: [ :fst :index1 | 
		(self allButFirst: index1) do: [ :snd | 
			aBlock value: fst value: snd ] ]! !

!SequenceableCollection methodsFor: '*RTVoronyjBuilder' stamp: 'NataliaTymchuk 6/27/2014 23:28'!
uniqueTriCombiDo: aBlock

	self size < 3 ifTrue: [ ^ self ].
	
	(self allButLast: 2) withIndexDo: [ :fst :index1 | 
		((self allButLast) allButFirst: index1) withIndexDo: [ :snd :index2 | 
				(self allButFirst: index1 + index2) do: [ :trd |
					aBlock value: fst value: snd value: trd ] ] ]! !

TestCase subclass: #RTVoronyjBuilderGCircleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder-Test'!

!RTVoronyjBuilderGCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 12:40'!
testPerpendicularBisectorsOn
		
	self
		assert:
			(((GCircle center: (-5@35) radius: 25.49509756796392 )
				perpendicularBisectorsOn: { -30 @ 40 . -10 @ 10 . 20 @ 30 . 0 @ 60 })
		 	at: (GSegment with: (-10@10) with: (20@30) ))
		equals: ((-5 @ 35) ray: (5@20))! !

TestCase subclass: #RTVoronyjBuilderGTriangleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder-Test'!

!RTVoronyjBuilderGTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 12:43'!
testPerpendicularBisectors

	| perpBisectors |

	perpBisectors := (GTriangle with: -30 @ 40 with: -10 @ 10 with: 20 @ 30) perpendicularBisectors.

	self
		assert: (perpBisectors at:(GSegment with:(-10@10) with:(20@30)))
		equals: (-5 @ 35 ray: 19.14213562373095@ -1.2132034355964265).
		
	self
		assert: (perpBisectors at:(GSegment with:(-30@40) with:(20@30)))
		equals: (-5 @ 35 ray: 0.0@60.0).	! !

!RTVoronyjBuilderGTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 12:44'!
testPerpendicularBisectors1

	self
		assert:
			((GTriangle with: 0 @ 0 with: 60 @ 90 with: -40 @ 300) perpendicularBisectors
				at:(GSegment with: 60 @ 90 with: -40 @ 300))
		equals: ((-1315/12)@(2485/18) ray: 169.13885009987717@270.7804048094653) .
! !

TestCase subclass: #RTVoronyjBuilderTest
	instanceVariableNames: 'builder builder1 builder2 builderCircle builder3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder-Test'!

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 12:36'!
setUp
	super setUp.
	builder := RTVoronyjBuilder new
		objects: { -1 @ 1 . 2 @ 3 . 5 @ -3 };
		positionBlock: #yourself;
		yourself.
	builder1 := RTVoronyjBuilder new
		objects: {  7 @ 4 . 5 @ 7 . -1 @ 1 . 2 @ 3 . 5 @ -3 };
		positionBlock: #yourself;
		yourself.
	builder2 := RTVoronyjBuilder new
		objects: {  -10 @ 10 . 20 @ 30 . 50 @ -30 . 30 @ 20 };
		positionBlock: #yourself;
		yourself.
	builderCircle := RTVoronyjBuilder new
		objects: {  10 @ 40 . 40 @ 10 . 10 @ -20 . -20 @ 10 };
		positionBlock: #yourself;
		yourself.
	builder3 := RTVoronyjBuilder new
		objects: {  -10 @ 10 . 20 @ 30 . 50 @ -30 . -30 @ 40 };
		positionBlock: #yourself;
		yourself.! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 00:10'!
testCutvectors
	self  
		assert: ((builder3 cutVectors
			at:  -10 @ 10) asSet )
		equals:   {(-46.0@7.66666666666666) . (-2.6666666666666665@ -44.0) . ((45/2)@ (-25/4)) . (-5@35) } asSet.
	self  
		assert: ((builder3 cutVectors
			at:  -30 @ 40) asSet )
		equals:   {(-1.2@54.0) . (-46.0@7.66666666666666) . (-5@35)} asSet.
	self  
		assert: ((builder3 cutVectors
			at:  20 @ 30) asSet )
		equals:   {(66.0@15.5) . (-1.2@54.0) . ((45/2)@ (-25/4)) . (-5@35)} asSet.
		self  
		assert: ((builder3 cutVectors
			at:  50 @ -30) asSet )
		equals:   {(66.0@15.5) . (-2.6666666666666665@ -44.0) . ((45/2)@ (-25/4))} asSet.
	
! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 12:47'!
testPerpBisectorsByEdges
	| bisectors |

	bisectors := builder3 perpBisectorsByEdges
		at: (GSegment with: -10 @ 10 with: 20 @ 30 ).
	
	self  
		assert: bisectors first
		equals: ((45/2) @ (-25/4) ray: 19.844355629253613@ -2.266533443880416).

	self  
		assert: bisectors last
		equals: (-5 @ 35 ray: 19.14213562373095@ -1.2132034355964265).
	! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 12:47'!
testPerpBisectorsByEdges2
	self  
		assert: (builder perpBisectorsByEdges
			at: (GSegment with: 2 @ 3 with: -1 @ 1 )) first origin
		equals:  (9/4) @ (-5/8).
	self  
		assert: (builder perpBisectorsByEdges 
			at: (GSegment with: -1 @ 1  with: 2 @ 3 )) first origin
		equals:  (9/4) @ (-5/8). 

	self  
		assert: (builder perpBisectorsByEdges  
			at: (GSegment with: 2 @ 3  with: 5 @ -3 )) first
		equals: ((9/4) @ (-5/8) ray: 6.75@1.625).
! !

!RTVoronyjBuilderTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 12:48'!
testVoronyjBuilder2
| v  o|

self flag: 'sort of stress test'.

v := RTView new.
v @ RTZoomableView.
o:=RTVoronyjBuilder new .
o objects: { 100 @ 200 . -40 @ 300 . 60 @ 90 . 0 @ 0
"-10 @ 10 . 20 @ 30 . 50 @ -30 . -30 @ 40 "}.
o positionBlock:#yourself.
	
o renderIn: v.

v 
	! !

!GCircle methodsFor: '*RTVoronyjBuilder' stamp: 'NataliaTymchuk 7/7/2014 11:29'!
perpBisTo: segm using:boundaryPoints
	| vector perpBisector |
	
	perpBisector := segm perpendicularBisector.

	vector := GRay 
		origin: center  
		direction: (perpBisector pointsWithDist: radius to: center) anyOne.


	(segm locationOf:(boundaryPoints detect: [ :p |
		 p ~= segm v1 and:
		[ p ~= segm v2 ]]))
	= 
	(segm locationOf: vector direction )
		ifTrue: [ ^ vector flipped ]
		ifFalse:[ ^ vector ]! !

!GCircle methodsFor: '*RTVoronyjBuilder' stamp: 'NataliaTymchuk 7/5/2014 18:29'!
perpendicularBisectorsOn: boundaryPoints
	|polygonSegm firstP notUsedPoints currentP|
	currentP := boundaryPoints anyOne.
	firstP := currentP.
	notUsedPoints := boundaryPoints asOrderedCollection remove: currentP; yourself.
	polygonSegm := Dictionary new.
	
	[ notUsedPoints isNotEmpty ] whileTrue: [
		| nextP segm |
		nextP := notUsedPoints detectMin: [ :point | point dist: currentP ].
		segm := GSegment with: currentP with: nextP.
		polygonSegm
			at: segm
			put: (self  perpBisTo: segm using: boundaryPoints ).
		currentP := nextP.
		notUsedPoints remove: currentP
			].
			
		polygonSegm
			at: ( GSegment with: currentP with: firstP)
			put: ( self perpBisTo: ( GSegment with: currentP with: firstP) using: boundaryPoints).
	
	^ polygonSegm! !

!GTriangle methodsFor: '*RTVoronyjBuilder' stamp: 'NataliaTymchuk 7/6/2014 13:40'!
perpendicularBisectors

	^ self circumscribedCircle perpendicularBisectorsOn: self vertices

"| center |
center := self circumscribedCircle center.
^ (self edgesByOpositeVertex associations collect:[ :assoc | |perp p1 p2|
	perp := assoc value perpendicularBisector.
	perp a = 0 
		ifFalse:[ p1 := (center x + 1) @ (perp yFor: center x + 1) .
					 p2 := (center x - 1) @ (perp yFor: center x - 1) ] 
		ifTrue:[ p1 := center + (1 @ 0).
				   p2 := center - (1 @ 0) ].
	
	assoc value ->
		(GVector
			origin: center
			direction: (
				(assoc key dist: p1) > (assoc key dist: p2)
					ifTrue: [ p1 ]
					ifFalse: [ p2 ])) ] ) asDictionary "! !

RTBuilder subclass: #RTAbstractVoronyjBuilder
	instanceVariableNames: 'objects dictPointsAndObject renderSites frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder'!

!RTAbstractVoronyjBuilder methodsFor: 'calculation' stamp: 'NataliaTymchuk 7/6/2014 23:48'!
addPointsFromFrameFor: site and: thePoints
| pOnFrame pairs newPoints |

self flag: 'This is a nasty hack to stretche cells to frame borders'.

pOnFrame := (thePoints select: [ :p |
	self frame hasOnBoundary: p ]) asOrderedCollection.
pairs := Set new.
newPoints := thePoints copy.

pOnFrame uniquePairsDo: [ :fst :snd | 
	((self frame sideWhichHas: fst) ~=
	  (self frame sideWhichHas: snd) ) ifTrue: [ 
		thePoints size = 2
			ifTrue: [ pairs add: { fst . snd } ]
			ifFalse: [ 
				((thePoints collectAsSet: [ :p |
					(fst segment: snd) locationOf: p ]) reject: #isZero) size = 1
						ifTrue: [ pairs add: { fst . snd } ] ] ] ].
				
	
"self halt."
	
pairs do:[:pair | 
	| segm locations |
	segm := GSegment with:  pair first  with: pair second.
	locations := (((self points copyWithout: site) collectAsSet: [ :p | segm locationOf: p ]) reject: #isZero ).
	
	locations size = 1 ifTrue: [
		newPoints addAll: (self frame vertices select: [ :v |
			(segm locationOf: v) = locations anyOne negated ]) ] ].
^ newPoints
! !

!RTAbstractVoronyjBuilder methodsFor: 'properties' stamp: 'NataliaTymchuk 6/26/2014 18:27'!
calculatePointsAndObject

	^ self subclassResponsibility ! !

!RTAbstractVoronyjBuilder methodsFor: 'private' stamp: 'NataliaTymchuk 7/6/2014 12:28'!
clearCache

	dictPointsAndObject := nil.
	frame := nil! !

!RTAbstractVoronyjBuilder methodsFor: 'calculation' stamp: 'NataliaTymchuk 7/7/2014 00:05'!
cutVectors
"2-nd step. (case with bag of points.) return dictionary with the triangle side as key and the perpendicular bisectors to it as value"
| dict |
dict:= Dictionary new.

(self perpBisectorsByEdges) keysAndValuesDo: [ :key :value| 

	((value size = 2 
		ifTrue:
			[ GSegment with: value first origin with: value last origin ]
		ifFalse:
			[ value first ]) cutWith: self frame) ifNotNilDo: [ :segment |
			{ key v1 . key v2 } do: [ :v | 
			(dict 
				at: v
				ifAbsentPut: [ Set new ]) add: segment v1; add: segment v2 ] ] ].
		
^ dict ! !

!RTAbstractVoronyjBuilder methodsFor: 'properties' stamp: 'NataliaTymchuk 6/26/2014 18:27'!
dictPointsAndObject

	^ dictPointsAndObject ifNil: [ 
		dictPointsAndObject := self calculatePointsAndObject ]! !

!RTAbstractVoronyjBuilder methodsFor: 'shape builder' stamp: 'NataliaTymchuk 6/23/2014 19:25'!
doNotRenderSites

	self renderSites: false! !

!RTAbstractVoronyjBuilder methodsFor: 'properties' stamp: 'NataliaTymchuk 7/6/2014 12:28'!
frame

	^ frame ifNil: [  
		| encompasingRectangle |

		encompasingRectangle := self points min corner: self points max.

		frame := encompasingRectangle expandBy: (encompasingRectangle extent * 0.2) ]! !

!RTAbstractVoronyjBuilder methodsFor: 'initialization' stamp: 'NataliaTymchuk 6/23/2014 19:25'!
initialize
	super initialize.
	self renderSites: true! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/16/2014 16:54'!
objects
	^ objects! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/26/2014 18:28'!
objects: anObject
	objects := anObject.
	self clearCache.! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 13:19'!
perpBisectorBySegmentsOnLine
"third step for the case when all points lye on the line. 
return dictionary with the segment as key and the perpendicular bisectors to it as value"
| dict|
dict:= Dictionary new.
(self centersBySegment) keysAndValuesDo: [ :iKey :iValue| 
	iValue size = 2 
	ifTrue:
		[dict at: iKey put:( GSegment with:(iValue at:1) with:(iValue at:2) )]
	ifFalse:
		[dict at: iKey put:( GSegment with:(iValue at:1) with: (self pointForClosestToBorder: iKey) )] ].
^dict ! !

!RTAbstractVoronyjBuilder methodsFor: 'calculation' stamp: 'NataliaTymchuk 7/7/2014 00:05'!
perpBisectorsByEdges
"first step: for every three point build triangle with circumscribed cirle. Take only that triangles that its circle doesn't have inside sites.
second step: return dictionary with the triangle side as key and the ______ as value"
	| dict collOfPolygons|
	collOfPolygons := OrderedCollection new.
	dict := Dictionary new.	
	self points uniqueTriCombiDo: [ :fst :snd :trd |
		| triangle |
		triangle := GTriangle with: fst with: snd with: trd.
		(triangle
			isDegenerate not and: 
			[collOfPolygons
				noneSatisfy: [ :polygon | polygon includesAll: {fst . snd . trd} ] ]) ifTrue: [
				| circle |
				"self halt.	"
				circle := triangle circumscribedCircle.
				((self points copyWithoutAll: {fst . snd . trd})
					noneSatisfy: [ :point | circle contains: point ]) ifTrue: [ 
						(((self points copyWithoutAll: {fst . snd . trd}) select: [ :point | circle boundaryContains: point ])
							ifEmpty: [ triangle perpendicularBisectors ]	
				  			ifNotEmptyDo: [ :pointsOnBoundary |
								circle perpendicularBisectorsOn: (collOfPolygons add: pointsOnBoundary, {fst . snd . trd}) ])
									keysAndValuesDo: [ :edge :perpBis |
										(dict
											at: edge
											ifAbsentPut: [ OrderedCollection new: 2 ]) add: perpBis ] ] ] ].
		^ dict ! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/28/2014 15:16'!
pointForClosestToBorder: segm
"return one of the intersection points with frame, which will be the second vertice of porpendicular bisector"
	| intPoints positionOfOther |
	intPoints := self frame intersectionPointsWithLine: (segm perpendicularBisector).
	positionOfOther := segm locationOf: (self points detect:[ :p |
		(segm locationOf: p) ~= 0 ]).
	^intPoints detect: [:point | 
			(segm locationOf: point) ~= positionOfOther ].
		
! !

!RTAbstractVoronyjBuilder methodsFor: 'properties' stamp: 'NataliaTymchuk 6/26/2014 21:26'!
points	
	^ self dictPointsAndObject keys! !

!RTAbstractVoronyjBuilder methodsFor: 'hooks' stamp: 'NataliaTymchuk 7/6/2014 12:55'!
renderIn: aView
| shapesByPoint |
shapesByPoint := self shapesByPoint.
self dictPointsAndObject keysAndValuesDo: [ :point :object | 
	aView add:
		(RTPolygon new
			vertices: ( shapesByPoint at: point) vertices;
			color: Color transparent;
			elementOn: object).
	self renderSites ifTrue: [  
		aView add:
			((RTEllipse new
				size: self frame extent min * 0.03;
				color: Color black;
				elementOn: object)
					translateTo: point;
					yourself) ] ]! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/23/2014 19:23'!
renderSites
	^ renderSites! !

!RTAbstractVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/23/2014 19:24'!
renderSites: aBoolean
	renderSites := aBoolean ! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 13:18'!
segmentsByPointsOnLine
"fourth step for the case when all points lye on the line. 
return dictionary with the site as key and the perpendicular bisectors (poligon segments) as value"
	| dict |
	dict := Dictionary new.
	self perpBisectorBySegmentsOnLine keysAndValuesDo:[:iKey :iValue|
		iKey vertices do:[:vert | 
			(dict at: vert ifAbsentPut: [OrderedCollection new]) add:iValue]  ].
	^ dict! !

!RTAbstractVoronyjBuilder methodsFor: 'calculation' stamp: 'NataliaTymchuk 7/6/2014 21:54'!
shapesByPoint
"4-th step. return dictionary with the site as key and the poligon vertices as value."
"close shape"
	^ (self cutVectors associations collect: [ :assoc |
		assoc key ->
		(GPolygon convexHullOn: (
		self addPointsFromFrameFor: assoc key and:
		assoc value)) ]) asDictionary.
! !

!RTAbstractVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/28/2014 15:20'!
whichSideHas: point betweenItselfAnd: segm
"return frame side which has between itself and segm the point, but not other points"
| position fram| 
	position := segm locationOf: ((self points copyWithout: point) detect:[ :p |
				(segm locationOf: p) ~= 0 ]).
			fram:= self frame.
	^(self frame edges) detect:[ :edge |
				(segm locationOf: edge v1)~= position  and:
				[(segm locationOf: edge v2)~= position]].! !

RTAbstractVoronyjBuilder subclass: #RTMDSVoronyjBuilder
	instanceVariableNames: 'relationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder'!

!RTMDSVoronyjBuilder class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:57'!
on: aCollection with: aBlock 
	^ self new on: aCollection with: aBlock! !

!RTMDSVoronyjBuilder methodsFor: 'properties' stamp: 'NataliaTymchuk 7/6/2014 12:33'!
calculatePointsAndObject
	
	| objectArray aMatrix coordinates dict |
	objectArray := objects asArray.
	aMatrix := DhbMatrix new: objectArray size.
	objectArray 
		withIndexDo: [ :fst :index1 | 
			(objectArray allButFirst: index1 - 1)
				withIndexDo: [ :snd :index2 | |a| a:= relationBlock value: fst value: snd.
					aMatrix
						at: index1 at: index1 + index2 - 1 put: a;
						at: index1 + index2 - 1 at: index1 put: a ] ].
	coordinates := self сoordinates: (self matrixBInMDS: aMatrix).
	dict := Dictionary new.
	coordinates rows withIndexDo:[ :vect :index | 
		dict at: (vect first * 500 @ vect last * 500) put: (objectArray at: index)].
	^dict ! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:55'!
jMatrixInMDS
	^ (DhbMatrix new: self numberOfItems with: [ :c :r | 
			c = r
				ifTrue: [ 1 ]
				ifFalse: [ 0 ] ]) - (DhbMatrix new: self numberOfItems with: [ :c :r | 1 / self numberOfItems ]) ! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:55'!
jMatrixInMDSOf: size
	^ (DhbMatrix new: size with: [ :c :r | 
			c = r
				ifTrue: [ 1 ]
				ifFalse: [ 0 ] ]) - (DhbMatrix new: size with: [ :c :r | 1 / size ])! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 18:55'!
matrixBInMDS: aMatrix

	^((DhbMatrix new: aMatrix rows size with: [ :c :r | 
			c = r
				ifTrue: [ -1/2 ]
				ifFalse: [ 0 ] ]) * (self jMatrixInMDSOf: aMatrix rows size))* (aMatrix collect: #squared ) * (self jMatrixInMDSOf: aMatrix rows size)! !

!RTMDSVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/25/2014 17:22'!
relationBlock
	^ relationBlock ! !

!RTMDSVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/26/2014 18:28'!
relationBlock: anObject
	relationBlock := anObject.
	self clearCache ! !

!RTMDSVoronyjBuilder methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 12:32'!
сoordinates: matrBInMDS
	| j matrixOfTwoEigenvalues matrixOfTwoTranspEigenvectors |
	j := DhbJacobiTransformation matrix: matrBInMDS.
	matrixOfTwoEigenvalues := DhbMatrix
		diagonal: ((j evaluate sort last: 2) collect: #sqrt).
	matrixOfTwoTranspEigenvectors := (DhbMatrix rows: (j transform rows first: 2)) transpose.
	^ matrixOfTwoTranspEigenvectors * matrixOfTwoEigenvalues! !

RTAbstractVoronyjBuilder subclass: #RTVoronyjBuilder
	instanceVariableNames: 'positionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder'!

!RTVoronyjBuilder methodsFor: 'properties' stamp: 'NataliaTymchuk 6/26/2014 18:45'!
calculatePointsAndObject
 |aDict|		
 aDict := Dictionary new.
 objects do: [ :object |
		 aDict at: (positionBlock value: object) put: object ].
 ^ aDict! !

!RTVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/25/2014 17:20'!
positionBlock
	^ positionBlock! !

!RTVoronyjBuilder methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/26/2014 18:29'!
positionBlock: anObject
	positionBlock := anObject.
	self clearCache ! !
